<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use App\Models\CarBodyStyle;
use Illuminate\Http\Request;

class CarbodystyleController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $data = array();

        $query = CarBodyStyle::query();

        if(isset($_REQUEST['year'])) {
            $query->where('year', 'like', '%'.$_REQUEST['year'].'%');
        }

        if(isset($_REQUEST['make'])) {
            $query->where('make', 'like', '%'.$_REQUEST['make'].'%');
        }

        if(isset($_REQUEST['model'])) {
            $query->where('model', 'like', '%'.$_REQUEST['model'].'%');
        }

        $carBodyStyles = $query->orderBy('name', 'asc')->get();

        if ($carBodyStyles->isNotEmpty()) {
            $data = [
                'status' => true,
                'data' => $carBodyStyles
            ];
        }
        else {
            $data = [
                'status' => false,
                'message' => 'No Car make found'
            ];
        }

        return response()->json([
            $data
        ]);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, string $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(string $id)
    {
        //
    }
}
