<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use App\Models\Product;
use Illuminate\Http\Request;

class ProductController extends Controller
{
    /**
     * Display Products.
     */
    public function index()
    {
        $data = array();

        $query = Product::query();

        if(isset($_REQUEST['year']) && !empty($_REQUEST['year'])) {
            $query->where('year', 'like', '%'.$_REQUEST['year'].'%');
        }

        if(isset($_REQUEST['make']) && !empty($_REQUEST['make'])) {
            $query->where('make', 'like', '%'.$_REQUEST['make'].'%');
        }

        if(isset($_REQUEST['model']) && !empty($_REQUEST['model'])) {
            $query->where('model', 'like', '%'.$_REQUEST['model'].'%');
        }

        if(isset($_REQUEST['bodystyle']) && !empty($_REQUEST['bodystyle'])) {
            $query->where('bodystyle', 'like', '%'.$_REQUEST['bodystyle'].'%');
        }

        $products = $query->orderBy('year', 'desc')->get();

        if ($products->isNotEmpty()) {
            $data = [
                'status' => true,
                'data' => $products,
            ];
        }
        else {
            $data = [
                'status' => false,
                'message' => 'No product found'
            ];

        }

        return response()->json([
            $data
        ]);
    }

    /**
     * Years List
     */
    public function yearsList() {
        $products = Product::all();
        $years = array();

        if(!empty($products)) {
            foreach($products as $product) {
                $year = $product->year;
                $yearExp = explode(',',$year);
                foreach($yearExp as $y) {
                    $years[] = trim($y); // Trim to remove any extra spaces
                }
            }

            // Remove duplicates
            $years = array_unique($years);
        }

        if ($products->isNotEmpty()) {
            $data = [
                'status' => true,
                'data' => $years,
            ];
        }
        else {
            $data = [
                'status' => false,
                'message' => 'No year found'
            ];

        }

        return response()->json([
            $data
        ]);

    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, string $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(string $id)
    {
        //
    }
}
